----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    02:44:44 07/09/2007 
-- Design Name: 
-- Module Name:    PC88MR64 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity PC88MR64 is
	Port (	GCLK		: in  std_logic;
		RIN		: in  std_logic_vector(3 downto 0);	-- Z,2,1,0
		GIN		: in  std_logic_vector(3 downto 0);
		BIN		: in  std_logic_vector(3 downto 0);
		ROUT		: out std_logic_vector(3 downto 0);	-- Z,2,1,0
		GOUT		: out std_logic_vector(3 downto 0);
		BOUT		: out std_logic_vector(3 downto 0);

		ENABLE		: in  std_logic	);

		attribute pin_assign : string;
		attribute pin_assign of GCLK : signal is "5";
		attribute pin_assign of RIN  : signal is "2,3,4,6";
		attribute pin_assign of GIN  : signal is "7,8,9,11";
		attribute pin_assign of BIN  : signal is "12,13,14,18";
		attribute pin_assign of ROUT : signal is "29,33,34,35";
		attribute pin_assign of GOUT : signal is "36,37,38,39";
		attribute pin_assign of BOUT : signal is "40,42,43,44";
		attribute pin_assign of ENABLE : signal is "1";
end PC88MR64;

architecture Behavioral of PC88MR64 is

	signal CNT : std_logic;
	signal SYNC : std_logic;
	signal SAMPLE_R: std_logic;
	signal SAMPLE_G: std_logic;
	signal SAMPLE_B: std_logic;
	signal SAMPLE_SYNC: std_logic;

begin

-- Main
	process ( GCLK ) begin
		if (GCLK = '1' and GCLK'event) then
			if (ENABLE = '1') then
				-- 64 color mode --
				if (CNT = '1') then
					ROUT <= (SAMPLE_R and RIN(1)) & SAMPLE_R & RIN(1) & SAMPLE_R;
					GOUT <= (SAMPLE_G and GIN(1)) & SAMPLE_G & GIN(1) & SAMPLE_G;
					BOUT <= (SAMPLE_B and BIN(1)) & SAMPLE_B & BIN(1) & SAMPLE_B;
				end if;
			else
				-- compatible mode (thru) --
				ROUT <= RIN;
				GOUT <= GIN;
				BOUT <= BIN;
			end if;
		end if;
	end process;

-- Odd/Even counter
	SYNC <= GIN(2) and (not GIN(0));
	process ( GCLK ) begin
		if (GCLK = '1' and GCLK'event) then
			SAMPLE_R <= RIN(1);
			SAMPLE_G <= GIN(1);
			SAMPLE_B <= BIN(1);
			SAMPLE_SYNC <= SYNC;
			if (SAMPLE_SYNC = '0' and SYNC = '1') then
				CNT <= '1';
			else
				CNT <= not CNT;
			end if;
		end if;
	end process;

end Behavioral;

